#ifndef GWDB_CTRL_H
#define GWDB_CTRL_H
/*
 * Domain Bridge Control
 *
 * Copyright 2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * --------------------------------------------------------------------------
 * $Id: dbctrl.h,v 1.2 2003/03/29 12:21:10 csmith Exp $
 * --------------------------------------------------------------------------
 */

#include "dbridge.h"

typedef enum{ Idle = 1, ReadACK } DataPhase;

typedef struct {
  GWStatus  result;
  int       error;
} GWRStatus;

typedef struct {
  char      buf[256];
  int       domlist_idx;
  int       pending_count;
  DataPhase phase;
  CString   headCS;
  DomainMessage *current_dm;
  GWRStatus status;
} DomSession;

typedef enum {
  EU_MY_SESSION_QUIT = 256,
  EU_NEW_MESSAGE,
  EU_MSG_PENDING,
  EU_DEAD_MESSAGES,
  
  EUT_ACK_TIMEOUT
} GWDB_UserEvents;

RetValue init_db_network();

#endif
