/*
 * Goldwater Server Bootstrapper
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *
 * $Revision: 1.2 $  $Date: 2003/03/29 12:21:11 $
 *
 * --------------------------------------------------------------------------
 * $Log: gwsrvinit.c,v $
 * Revision 1.2  2003/03/29 12:21:11  csmith
 * cvs merge to 0.3.4
 *
 * Revision 1.9  2003/03/25 21:16:24  chris
 * Enable auto-recycle of servers
 *
 * Revision 1.8  2002/05/13 19:58:49  chris
 * Additional functionality to support the Domain Bridge.
 * Now allows __gw_get_request to 'not block' on request queue, and to
 * indicate that it returned because no messages were available.
 * More flags to control this behaviour (both control and private_user).
 *
 * Revision 1.7  2002/05/12 14:03:13  chris
 * GPL licence headers etc
 *
 * Revision 1.6  2002/01/29 22:43:40  chris
 * Cleaned up warnings.
 * Added gwp_ prefix to shutdown_server.
 * Added regdata.[ch] config entry to build.
 *
 * Revision 1.5  2001/12/26 22:57:43  chris
 * Changed all references to Imagepage Computing to netFluid Technology.
 *
 * Revision 1.4  2001/03/22 16:59:21  chris
 * Added revlog to top file comment
 *
 * --------------------------------------------------------------------------
 */

#include <gwapi.h>
#include <stdlib.h>

/* ------------------------------------------------------------------------- */

int
main( int argc, char **argv )
{
  int   done = 0;
  char *f    = 0;
  char *s    = 0;
  char *d    = 0;
  long fl    = 0;

  __gw_server_init( argc, argv );

  do {

    /* Block until a request comes in.... */
    __gw_get_request( &f, &s, &d, &fl );	
    
    done = ( __gw_invoke_C_service() < 0 ) ? 0 : 1;
    
	/* complete request will return 0 when it's time for the server to
	 * exit gracefully (if configured to do so by setting a max requests
	 * value in the configuration.
	 *
	 * done == 1 will update BB counters 
	 */
  } while( __gw_complete_request(done) ); 

  /* Graceful Shutdown */
  exit(0);
  return 0;
}

/* ------------------------------------------------------------------------ */
/* end */
