/*
 * Core level logging functions
 *
 * Multiplexed Network Client/Server Core Engine
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * -----------------------------------------------------------------------
 * $Id: logging.c,v 1.2 2003/03/29 12:21:11 csmith Exp $  $Date: 2003/03/29 12:21:11 $
 * -----------------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>

#include "logging.h"

#define GOLDWATER 1  /* FORCE GOLDWATER COMPILE! */


#ifdef GOLDWATER
#  include <gwlog.h>
#else
#  include <phlib/xl_logging.h>
#endif

static char lb[16384];

/* ------------------------------------------------------------------------ */
void
ph_open_log()
{
#ifndef GOLDWATER
  PhoenixLog = init_ulflog( 9999, 4096, NULL );
#endif
}


/* ------------------------------------------------------------------------ */

void
ph_close_log()
{
#ifndef GOLDWATER
  finish_ulflog( PhoenixLog );
#endif
}

/* ------------------------------------------------------------------------ */
/* 
 */
void
ph_logf( int level, char *format, ... )
{
  va_list ap;

  va_start(ap,format);
  vsprintf( lb, format, ap );
#ifndef GOLDWATER
  ulflog( PhoenixLog, level, lb );
#else
  {
     int lev = -1;
	 
	 if( level <= 100 ) lev = LOG_INTDBG;
	 if( level <= 5   ) lev = LOG_INFO;
	 if( level <= 2   ) lev = LOG_ALWAYS;
  
     if( lev != -1 ) gw_log( lev, lb, strlen(lb) );
   }
#endif
  va_end(ap);
}

/* ------------------------------------------------------------------------ */

void
ph_flush_log()
{
#ifndef GOLDWATER
  flush_ulflog();
#endif
}

/* ------------------------------------------------------------------------ */
/* end */
